Index: squid/doc/Programming-Guide/prog-guide.sgml
===================================================================
RCS file: /cvsroot/squid-sf//squid/doc/Programming-Guide/prog-guide.sgml,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/doc/Programming-Guide/prog-guide.sgml	26 Jan 2000 03:23:10 -0000	1.1.1.1
+++ squid/doc/Programming-Guide/prog-guide.sgml	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -799,73 +1137,81 @@
 
 <sect1> Introduction
 
-<P>
-The IP cache is a built-in component of squid providing
-Hostname to IP-Number translation functionality and managing 
-the involved data-structures. Efficiency concerns require
-mechanisms that allow non-blocking access to these mappings.
-The IP cache usually doesn't block on a request except for special 
-cases where this is desired (see below).
+	<P>
+	The IP cache is a built-in component of squid providing
+	Hostname to IP-Number translation functionality and managing
+	the involved data-structures. Efficiency concerns require
+	mechanisms that allow non-blocking access to these mappings.
+	The IP cache usually doesn't block on a request except for
+	special cases where this is desired (see below).
 
 <sect1> Data Structures 
 
-<P>
-The data structure used for storing name-address mappings
-is a small hashtable (<em>static hash_table *ip_table</em>),
-where structures of type <em>ipcache_entry</em> whose most
-interesting members are:
+	<P>
+	The data structure used for storing name-address mappings
+	is a small hashtable (<em>static hash_table *ip_table</em>),
+	where structures of type <em>ipcache_entry</em> whose most
+	interesting members are:
 
 <verb>
-struct _ipcache_entry {
-char *name;
-time_t lastref;
-ipcache_addrs addrs;
-struct _ip_pending *pending_head;
-char *error_message;
-unsigned char locks;
-ipcache_status_t status:3;
-}
+	struct _ipcache_entry {
+		char *name;
+		time_t lastref;
+		ipcache_addrs addrs;
+		struct _ip_pending *pending_head;
+		char *error_message;
+		unsigned char locks;
+		ipcache_status_t status:3;
+	}
 </verb>
 
 
 <sect1> External overview
 
-<P>
-Main functionality
-is provided through calls to:
-<descrip>
-<tag>ipcache_nbgethostbyname(const char *name, IPH *handler, void *handlerdata)
-</tag>
-where <em/name/ is the name of the host to resolve, <em/handler/ is a 
-pointer to the function to be called when the reply from the IP cache (or
-the DNS if the IP cache misses) and <em/handlerdata/ is information that
-is passed to the handler and does not affect the IP cache.
-<tag>ipcache_gethostbyname(const char *name,int flags)</tag>
-is different in that
-it only checks if an entry exists in it's data-structures and does not by
-default contact the DNS, unless this is requested, by setting the <em/flags/ to
-<em/IP_BLOCKING_LOOKUP/ or <em/IP_LOOKUP_IF_MISS/.
-<tag>ipcache_init()</tag> is called from <em/mainInitialize()/ after disk
-initialization and prior to the reverse fqdn cache initialization
-<tag>ipcache_restart()</tag> is called to clear the IP cache's data structures,
-cancel all pending requests. Currently, it is only called from
-<em/mainReconfigure/.
-</descrip>
+	<P>
+	Main functionality
+	is provided through calls to:
+	<descrip>
+
+	<tag>ipcache_nbgethostbyname(const char *name, IPH *handler,
+	void *handlerdata)</tag>
+	where <em/name/ is the name of the host to resolve,
+	<em/handler/ is a pointer to the function to be called when
+	the reply from the IP cache (or the DNS if the IP cache
+	misses) and <em/handlerdata/ is information that is passed
+	to the handler and does not affect the IP cache.
+
+	<tag>ipcache_gethostbyname(const char *name,int flags)</tag>
+	is different in that it only checks if an entry exists in
+	it's data-structures and does not by default contact the
+	DNS, unless this is requested, by setting the <em/flags/
+	to <em/IP_BLOCKING_LOOKUP/ or <em/IP_LOOKUP_IF_MISS/.
+
+	<tag>ipcache_init()</tag> is called from <em/mainInitialize()/
+	after disk initialization and prior to the reverse fqdn
+	cache initialization
+
+	<tag>ipcache_restart()</tag> is called to clear the IP
+	cache's data structures, cancel all pending requests.
+	Currently, it is only called from <em/mainReconfigure/.
+
+	</descrip>
 
 <sect1> Internal Operation 
 
-<P>
-Internally, the execution flow is as follows: On a miss, 
- <em/ipcache_getnbhostbyname/ checks whether a request for this name is already
-pending, and if positive, it creates a new entry using <em/ipcacheAddNew/ with
-the <em/IP_PENDING/ flag set . Then it calls <em/ipcacheAddPending/ to add a
-request to the queue together with data and handler.
-Else, <em/ipcache_dnsDispatch()/ is called to
-directly create a DNS query or to <em/ipcacheEnqueue()/ if all no DNS port is
-free.
-<em/ipcache_call_pending()/ is called regularly to walk down the pending
-list and call handlers. LRU clean-up is performed through <em/ipcache_purgelru()/
-according to the <em/ipcache_high/ threshold.
+	<P>
+	Internally, the execution flow is as follows: On a miss,
+	<em/ipcache_getnbhostbyname/ checks whether a request for
+	this name is already pending, and if positive, it creates
+	a new entry using <em/ipcacheAddNew/ with the <em/IP_PENDING/
+	flag set . Then it calls <em/ipcacheAddPending/ to add a
+	request to the queue together with data and handler.  Else,
+	<em/ipcache_dnsDispatch()/ is called to directly create a
+	DNS query or to <em/ipcacheEnqueue()/ if all no DNS port
+	is free.  <em/ipcache_call_pending()/ is called regularly
+	to walk down the pending list and call handlers. LRU clean-up
+	is performed through <em/ipcache_purgelru()/ according to
+	the <em/ipcache_high/ threshold.
 
 <!-- %%%% Chapter : SERVER PROTOCOLS %%%% -->
 <sect>Server Protocols
@@ -896,7 +1242,7 @@
 
 <sect>Callback Data Database
 
-<P>
+	<P>
 	Squid's extensive use of callback functions makes it very
 	susceptible to memory access errors.  For a blocking operation
 	with callback functions, the normal sequence of events is as
@@ -915,7 +1261,7 @@
 	to free the callback_data, or otherwise cancel the callback,
 	before the operation completes.
 
-<P>
+	<P>
 	The callback data database lets us do this in a uniform and
 	safe manner.  Every callback_data pointer must be added to the
 	database.  It is then locked while the blocking operation executes
@@ -935,7 +1281,7 @@
 	cbdataFree(callback_data);
 </verb>
 
-<P>
+	<P>
 	With this scheme, nothing bad happens if <tt/cbdataFree/ gets called
 	before <tt/cbdataUnlock/:
 <verb>
@@ -964,16 +1310,18 @@
 
 <!-- %%%% Chapter : HTTP Headers %%%% -->
 <sect>HTTP Headers
-<P>
-<em/Files:/
-	<tt/HttpHeader.c/,
-	<tt/HttpHeaderTools.c/,
-	<tt/HttpHdrCc.c/,
-	<tt/HttpHdrContRange.c/,
-	<tt/HttpHdrExtField.c/,
-	<tt/HttpHdrRange.c/
 
-<P> 
+	<P>
+	<em/Files:/
+        <tt/HttpHeader.c/,
+        <tt/HttpHeaderTools.c/,
+        <tt/HttpHdrCc.c/,
+        <tt/HttpHdrContRange.c/,
+        <tt/HttpHdrExtField.c/,
+        <tt/HttpHdrRange.c/
+
+
+	<P> 
 	<tt/HttpHeader/ class encapsulates methods and data for HTTP header
 	manipulation.  <tt/HttpHeader/ can be viewed as a collection of HTTP
 	header-fields with such common operations as add, delete, and find.
@@ -983,7 +1331,7 @@
 
 <sect1>General remarks
 
-<P>
+	<P>
 	<tt/HttpHeader/ is a collection (or array) of HTTP header-fields. A header
 	field is represented by an <tt/HttpHeaderEntry/ object. <tt/HttpHeaderEntry/ is
 	an (id, name, value) triplet.  Meaningful "Id"s are defined for
@@ -992,7 +1340,7 @@
 	<em/HDR_OTHER/.  Ids are formed by capitalizing the corresponding HTTP
 	header-field name and replacing dashes ('-') with underscores ('_').
 
-<P>
+	<P>
 	Most operations on <tt/HttpHeader/ require a "known" id as a parameter. The
 	rationale behind the later restriction is that Squid programmer should
 	operate on "known" fields only. If a new field is being added to
@@ -1000,7 +1348,7 @@
  
 <sect1>Life cycle
 
-<P> 
+	<P> 
 	<tt/HttpHeader/ follows a common pattern for object initialization and
 	cleaning:
 
@@ -1018,64 +1366,75 @@
     httpHeaderClean(&amp;hdr);
 </verb>
 
-<P> 
-	Prior to use, an <tt/HttpHeader/ must be initialized. A programmer must
-	specify if a header belongs to a request or reply message. The
-	"ownership" information is used mostly for statistical purposes.
-
-<P>
-	Once initialized, the <tt/HttpHeader/ object <em/must/ be, eventually,
-	cleaned.  Failure to do so will result in a memory leak.
-
-<P>
-	Note that there are no methods for "creating" or "destroying" a
-	"dynamic" <tt/HttpHeader/ object. Looks like headers are always stored as a
-	part of another object or as a temporary variable. Thus, dynamic
-	allocation of headers is not needed.
+	<P> 
+	Prior to use, an <tt/HttpHeader/ must be initialized. A
+	programmer must specify if a header belongs to a request
+	or reply message. The "ownership" information is used mostly
+	for statistical purposes.
+
+	<P>
+	Once initialized, the <tt/HttpHeader/ object <em/must/ be,
+	eventually, cleaned.  Failure to do so will result in a
+	memory leak.
+
+	<P>
+	Note that there are no methods for "creating" or "destroying"
+	a "dynamic" <tt/HttpHeader/ object. Looks like headers are
+	always stored as a part of another object or as a temporary
+	variable. Thus, dynamic allocation of headers is not needed.
 
 
 <sect1>Header Manipulation.
 
-<P>
-	The mostly common operations on HTTP headers are testing for a particular
-	header-field (<tt/httpHeaderHas()/), extracting field-values (<tt/httpHeaderGet*()/), and
-	adding new fields (<tt/httpHeaderPut*()/).
-
-<P>
-	<tt/httpHeaderHas(hdr, id)/ returns true if at least one header-field specified by
-	"id" is present in the header. Note that using <em/HDR_OTHER/ as an id is
-	prohibited.  There is usually no reason to know if there are "other"
+	<P>
+	The mostly common operations on HTTP headers are testing
+	for a particular header-field (<tt/httpHeaderHas()/),
+	extracting field-values (<tt/httpHeaderGet*()/), and adding
+	new fields (<tt/httpHeaderPut*()/).
+
+	<P>
+	<tt/httpHeaderHas(hdr, id)/ returns true if at least one
+	header-field specified by "id" is present in the header.
+	Note that using <em/HDR_OTHER/ as an id is prohibited.
+	There is usually no reason to know if there are "other"
 	header-fields in a header.
 
-<P>
-	<tt/httpHeaderGet&lt;Type&gt;(hdr, id)/ returns the value of the specified header-field.
-	The "Type" must match header-field type. If a header is not present a "null"
-	value is returned. "Null" values depend on field-type, of course.
-
-<P>
-	Special care must be taken when several header-fields with the same id are
-	preset in the header. If HTTP protocol allows only one copy of the specified
-	field per header (e.g. "Content-Length"), <tt/httpHeaderGet&lt;Type&gt;()/ will return
-	one of the field-values (chosen semi-randomly). If HTTP protocol allows for
-	several values (e.g. "Accept"), a "String List" will be returned.
-
-<P>
-	It is prohibited to ask for a List of values when only one value is permitted,
-	and visa-versa. This restriction prevents a programmer from processing one
-	value of an header-field while ignoring other valid values.
-
-<P>
-	<tt/httpHeaderPut&lt;Type&gt;(hdr, id, value)/ will add an header-field with a specified
-	field-name (based on "id") and field_value. The location of the newly added
-	field in the header array is undefined, but it is guaranteed to be after all
-	fields with the same "id" if any. Note that old header-fields with the same id
-	(if any) are not altered in any way.
-
-<P>
-	The value being put using one of the <tt/httpHeaderPut()/ methods is converted to
-	and stored as a String object.
+	<P>
+	<tt/httpHeaderGet&lt;Type&gt;(hdr, id)/ returns the value
+	of the specified header-field.  The "Type" must match
+	header-field type. If a header is not present a "null"
+	value is returned. "Null" values depend on field-type, of
+	course.
+
+	<P>
+	Special care must be taken when several header-fields with
+	the same id are preset in the header. If HTTP protocol
+	allows only one copy of the specified field per header
+	(e.g. "Content-Length"), <tt/httpHeaderGet&lt;Type&gt;()/
+	will return one of the field-values (chosen semi-randomly).
+	If HTTP protocol allows for several values (e.g. "Accept"),
+	a "String List" will be returned.
+
+	<P>
+	It is prohibited to ask for a List of values when only one
+	value is permitted, and visa-versa. This restriction prevents
+	a programmer from processing one value of an header-field
+	while ignoring other valid values.
+
+	<P>
+	<tt/httpHeaderPut&lt;Type&gt;(hdr, id, value)/ will add an
+	header-field with a specified field-name (based on "id")
+	and field_value. The location of the newly added field in
+	the header array is undefined, but it is guaranteed to be
+	after all fields with the same "id" if any. Note that old
+	header-fields with the same id (if any) are not altered in
+	any way.
+
+	<P>
+	The value being put using one of the <tt/httpHeaderPut()/
+	methods is converted to and stored as a String object.
 
-<P>
+	<P>
 	Example:
 
 <verb>
@@ -1085,21 +1444,21 @@
 		httpHeaderPutInt(hdr, HDR_AGE, age);
 </verb>
 
-<P>
-	There are two ways to delete a field from a header. To delete a "known" field
-	(a field with "id" other than <em/HDR_OTHER/), use <tt/httpHeaderDelById()/ function.
-	Sometimes, it is convenient to delete all fields with a given name ("known" or
-	not) using <tt/httpHeaderDelByName()/ method. Both methods will delete <em/all/ fields
-	specified.
-
-
-<P>
-
-	The <em/httpHeaderGetEntry(hdr, pos)/ function can be used for
-	iterating through all fields in a given header. Iteration is
-	controlled by the <em/pos/ parameter. Thus, several concurrent
-	iterations over one <em/hdr/ are possible. It is also safe to
-	delete/add fields from/to <em/hdr/ while iteration is in progress.
+	<P>
+	There are two ways to delete a field from a header. To
+	delete a "known" field (a field with "id" other than
+	<em/HDR_OTHER/), use <tt/httpHeaderDelById()/ function.
+	Sometimes, it is convenient to delete all fields with a
+	given name ("known" or not) using <tt/httpHeaderDelByName()/
+	method. Both methods will delete <em/all/ fields specified.
+
+	<P>
+	The <em/httpHeaderGetEntry(hdr, pos)/ function can be used
+	for iterating through all fields in a given header. Iteration
+	is controlled by the <em/pos/ parameter. Thus, several
+	concurrent iterations over one <em/hdr/ are possible. It
+	is also safe to delete/add fields from/to <em/hdr/ while
+	iteration is in progress.
 
 <verb>
 	/* delete all fields with a given name */
@@ -1111,79 +1470,268 @@
 	}
 </verb>
 
-	Note that <em/httpHeaderGetEntry()/ is a low level function and must
-	not be used if high level alternatives are available. For example, to
-	delete an entry with a given name, use the <em/httpHeaderDelByName()/
-	function rather than the loop above.
+	Note that <em/httpHeaderGetEntry()/ is a low level function
+	and must not be used if high level alternatives are available.
+	For example, to delete an entry with a given name, use the
+	<em/httpHeaderDelByName()/ function rather than the loop
+	above.
 
 <sect1>I/O and Headers.
 
-<P>
-	To store a header in a file or socket, pack it using <tt/httpHeaderPackInto()/
-	method and a corresponding "Packer". Note that <tt/httpHeaderPackInto/ will pack
-	only header-fields; request-lines and status-lines are not prepended, and
-	CRLF is not appended. Remember that neither of them is a part of HTTP
-	message header as defined by the HTTP protocol.
+	<P>
+	To store a header in a file or socket, pack it using
+	<tt/httpHeaderPackInto()/ method and a corresponding
+	"Packer". Note that <tt/httpHeaderPackInto/ will pack only
+	header-fields; request-lines and status-lines are not
+	prepended, and CRLF is not appended. Remember that neither
+	of them is a part of HTTP message header as defined by the
+	HTTP protocol.
 
 
 <sect1>Adding new header-field ids.
 
-<P> 
-	Adding new ids is simple. First add new HDR_ entry to the http_hdr_type
-	enumeration in enums.h. Then describe a new header-field attributes in
-	the HeadersAttrs array located in <tt/HttpHeader.c/. The last
-	attribute specifies field type. Five types are supported: integer
-	(<em/ftInt/), string (<em/ftStr/), date in RFC 1123 format
-	(<em/ftDate_1123/), cache control field (<em/ftPCc/), range field
-	(<em/ftPRange/), and content range field (<em/ftPContRange/).  Squid
-	uses type information to convert internal binary representation of
-	fields to their string representation (<tt/httpHeaderPut/ functions)
-	and visa-versa (<tt/httpHeaderGet/ functions).
+	<P> 
+	Adding new ids is simple. First add new HDR_ entry to the
+	http_hdr_type enumeration in enums.h. Then describe a new
+	header-field attributes in the HeadersAttrs array located
+	in <tt/HttpHeader.c/. The last attribute specifies field
+	type. Five types are supported: integer (<em/ftInt/), string
+	(<em/ftStr/), date in RFC 1123 format (<em/ftDate_1123/),
+	cache control field (<em/ftPCc/), range field (<em/ftPRange/),
+	and content range field (<em/ftPContRange/).  Squid uses
+	type information to convert internal binary representation
+	of fields to their string representation (<tt/httpHeaderPut/
+	functions) and visa-versa (<tt/httpHeaderGet/ functions).
 
-<P>
+	<P>
 	Finally, add new id to one of the following arrays:
-	<em/GeneralHeadersArr/, <em/EntityHeadersArr/, <em/ReplyHeadersArr/,
-	<em/RequestHeadersArr/.  Use HTTP specs to determine the applicable
-	array.  If your header-field is an "extension-header", its place is in
-	<em/ReplyHeadersArr/ and/or in <em/RequestHeadersArr/. You can also
-	use <em/EntityHeadersArr/ for "extension-header"s that can be used
-	both in replies and requests.  Header fields other than
-	"extension-header"s must go to one and only one of the arrays
-	mentioned above.
+	<em/GeneralHeadersArr/, <em/EntityHeadersArr/,
+	<em/ReplyHeadersArr/, <em/RequestHeadersArr/.  Use HTTP
+	specs to determine the applicable array.  If your header-field
+	is an "extension-header", its place is in <em/ReplyHeadersArr/
+	and/or in <em/RequestHeadersArr/. You can also use
+	<em/EntityHeadersArr/ for "extension-header"s that can be
+	used both in replies and requests.  Header fields other
+	than "extension-header"s must go to one and only one of
+	the arrays mentioned above.
 
-<P>
+	<P>
 	Also, if the new field is a "list" header, add it to the
-	<em/ListHeadersArr/ array.  A "list" field-header is the one that is
-	defined (or can be defined) using "#" BNF construct described in the
-	HTTP specs. Essentially, a field that may have more than one valid
-	field-value in a single header is a "list" field.
+	<em/ListHeadersArr/ array.  A "list" field-header is the
+	one that is defined (or can be defined) using "&num;" BNF
+	construct described in the HTTP specs. Essentially, a field
+	that may have more than one valid field-value in a single
+	header is a "list" field.
+
+	<P>
+	In most cases, if you forget to include a new field id in
+	one of the required arrays, you will get a run-time assertion.
+	For rarely used fields, however, it may take a long time
+	for an assertion to be triggered.
+
+	<P>
+	There is virtually no limit on the number of fields supported
+	by Squid. If current mask sizes cannot fit all the ids (you
+	will get an assertion if that happens), simply enlarge
+	HttpHeaderMask type in <tt/typedefs.h/.
 
-<P>
-	In most cases, if you forget to include a new field id in one of the required
-	arrays, you will get a run-time assertion. For rarely used fields, however, it
-	may take a long time for an assertion to be triggered.
 
-<P>
-	There is virtually no limit on the number of fields supported by Squid. If
-	current mask sizes cannot fit all the ids (you will get an assertion if that
-	happens), simply enlarge HttpHeaderMask type in <tt/typedefs.h/.
+<sect1>A Word on Efficiency.
 
+	<P>
+	<tt/httpHeaderHas()/ is a very cheap (fast) operation
+	implemented using a bit mask lookup.
 
-<sect1>A Word on Efficiency.
+	<P>
+	Adding new fields is somewhat expensive if they require
+	complex conversions to a string.
 
-<P>
-	<tt/httpHeaderHas()/ is a very cheap (fast) operation implemented using a bit mask
-	lookup.
+	<P>
+	Deleting existing fields requires scan of all the entries
+	and comparing their "id"s (faster) or "names" (slower) with
+	the one specified for deletion.
 
-<P>
-	Adding new fields is somewhat expensive if they require complex conversions to
-	a string.
+	<P>
+	Most of the operations are faster than their "ascii string"
+	equivalents.
+
+<sect>File Formats
+
+<sect1><em/swap.state/
 
 <P>
-	Deleting existing fields requires scan of all the entries and comparing their
-	"id"s (faster) or "names" (slower) with the one specified for deletion.
+NOTE: this information is current as of version 2.2.STABLE4.
 
 <P>
-	Most of the operations are faster than their "ascii string" equivalents.
+A <em/swap.state/ entry is defined by the <em/storeSwapLogData/
+structure, and has the following elements:
+<verb>
+struct _storeSwapLogData {
+    char op;
+    int swap_file_number;
+    time_t timestamp;
+    time_t lastref;
+    time_t expires;
+    time_t lastmod;
+    size_t swap_file_sz;
+    u_short refcount;
+    u_short flags;
+    unsigned char key[MD5_DIGEST_CHARS];
+};
+</verb>
+
+<descrip>
+<tag/op/
+	Either SWAP_LOG_ADD (1) when an object is added to
+	the disk storage, or SWAP_LOG_DEL (2) when an object is
+	deleted.
+
+<tag/swap_file_number/
+	The 32-bit file number which maps to a pathname.  Only
+	the low 24-bits are relevant.  The high 8-bits are
+	used as an index to an array of storage directories, and
+	are set at run time because the order of storage directories
+	may change over time.
+
+<tag/timestamp/
+	A 32-bit Unix time value that represents the time when
+	the origin server generated this response.  If the response
+	has a valid <em/Date:/ header, this timestamp corresponds
+	to that time.  Otherwise, it is set to the Squid process time
+	when the response is read (as soon as the end of headers are
+	found).
+
+<tag/lastref/
+	The last time that a client requested this object.
+	Strictly speaking, this time is set whenver the StoreEntry
+	is locked (via <em/storeLockObject()/). 
+
+<tag/expires/
+	The value of the response's <em/Expires:/ header, if any.
+	If the response does not have an <em/Expires:/ header, this
+	is set to -1.  If the response has an invalid (unparseable)
+	<em/Expires:/ header, it is also set to -1.  There are some cases
+	where Squid sets <em/expires/ to -2.  This happens for the
+	internal ``netdb'' object and for FTP URL responses.
+
+<tag/lastmod/
+	The value of the response's <em/Last-modified:/ header, if any.
+	This is set to -1 if there is no <em/Last-modified:/ header,
+	or if it is unparseable.
+
+<tag/swap_file_sz/
+	This is the number of bytes that the object occupies on
+	disk.  It includes the Squid ``swap file header''.
+
+<tag/refcount/
+	The number of times that this object has been accessed (referenced).
+	Since its a 16-bit quantity, it is susceptible to overflow
+	if a single object is accessed 65,536 times before being replaced.
+
+<tag/flags/
+	A copy of the <em/StoreEntry/ flags field.  Used as a sanity
+	check when rebuilding the cache at startup.  Objects that
+	have the KEY_PRIVATE flag set are not added back to the cache.
+
+<tag/key/
+	The 128-bit MD5 hash for this object.
+	
+</descrip>
+
+Note that <em/storeSwapLogData/ entries are written in native machine
+byte order.  They are not necessarily portable across architectures.
+
+<sect>Store ``swap meta'' Description
+<p>
+``swap meta'' refers to a section of meta data stored at the beginning
+of an object that is stored on disk.  This meta data includes information
+such as the object's cache key (MD5), URL, and part of the StoreEntry
+structure.
+
+<p>
+The meta data is stored using a TYPE-LENGTH-VALUE format.  That is,
+each chunk of meta information consists of a TYPE identifier, a
+LENGTH field, and then the VALUE (which is LENGTH octets long).
+
+<sect1>Types
+
+<p>
+As of Squid-2.3, the following TYPES are defined (from <em/enums.h/):
+<descrip>
+<tag/STORE_META_VOID/
+	Just a placeholder for the zeroth value.   It is never used
+	on disk.
+
+<tag/STORE_META_KEY_URL/
+	This represents the case when we use the URL as the cache
+	key, as Squid-1.1 does.  Currently we don't support using
+	a URL as a cache key, so this is not used.
+
+<tag/STORE_META_KEY_SHA/
+	For a brief time we considered supporting SHA (secure
+	hash algorithm) as a cache key.  Nobody liked it, and
+	this type is not currently used.
+
+<tag/STORE_META_KEY_MD5/
+	This represents the MD5 cache key that Squid currently uses.
+	When Squid opens a disk file for reading, it can check that
+	this MD5 matches the MD5 of the user's request.  If not, then
+	something went wrong and this is probably the wrong object.
+
+<tag/STORE_META_URL/
+	The object's URL.  This also may be matched against a user's
+	request for cache hits to make sure we got the right object.
+
+<tag/STORE_META_STD/
+	This is the ``standard metadata'' for an object.  Really
+	its just this middle chunk of the StoreEntry structure:
+<verb>
+	time_t timestamp;
+	time_t lastref;
+	time_t expires;
+	time_t lastmod;
+	size_t swap_file_sz;
+	u_short refcount;
+	u_short flags;
+</verb>
+
+<tag/STORE_META_HITMETERING/
+	Reserved for future hit-metering (RFC 2227) stuff.
+
+<tag/STORE_META_VALID/
+	?
+
+<tag/STORE_META_END/
+	Marks the last valid META type.
+
+</descrip>
+
+
+<sect1>Implementation Notes
+
+<p>
+When writing an object to disk, we must first write the meta data.
+This is done with a couple of functions.  First, <tt/storeSwapMetaPack()/
+takes a <em/StoreEntry/ as a parameter and returns a <em/tlv/ linked
+list.  Second, <tt/storeSwapMetaPack()/ converts the <em/tlv/ list
+into a character buffer that we can write.
+
+<p>
+Note that the <em/MemObject/ has a member called <em/swap_hdr_sz/.
+This value is the size of that character buffer; the size of the
+swap file meta data.  The <em/StoreEntry/ has a member named
+<em/swap_file_sz/ that represents the size of the disk file.
+Thus, the size of the object ``content'' is
+<verb>
+	StoreEntry->swap_file_sz  - MemObject->swap_hdr_sz;
+</verb>
+Note that the swap file content includes the HTTP reply headers
+and the HTTP reply body (if any).
+
+<p>
+When reading a swap file, there is a similar process to extract
+the swap meta data.  First, <tt/storeSwapMetaUnpack()/ converts a
+character buffer into a <em/tlv/ linked list.  It also tells us
+the value for <em/MemObject->swap_hdr_sz/.
 
 </article>
Index: squid/errors/Bulgarian/ERR_ACCESS_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_ACCESS_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_ACCESS_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_ACCESS_DENIED	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Çàÿâåíèÿò îáåêò íå ìîæå äà áúäå äîñòàâåí</TITLE>
 </HEAD><BODY>
 <H1>ÃÐÅØÊÀ</H1>
Index: squid/errors/Bulgarian/ERR_CACHE_ACCESS_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_CACHE_ACCESS_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_CACHE_ACCESS_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_CACHE_ACCESS_DENIED	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Äîñòúï äî êåøà îòêàçàí</TITLE>
 </HEAD>
 <BODY>
Index: squid/errors/Bulgarian/ERR_CACHE_MGR_ACCESS_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_CACHE_MGR_ACCESS_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_CACHE_MGR_ACCESS_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_CACHE_MGR_ACCESS_DENIED	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Îòêàçàí äîñòúï äî êåø ìåíèäæúðà</TITLE>
 </HEAD>
 <BODY>
Index: squid/errors/Bulgarian/ERR_CANNOT_FORWARD
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_CANNOT_FORWARD,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_CANNOT_FORWARD	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_CANNOT_FORWARD	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Çàÿâåíèÿò îáåêò íå ìîæå äà áúäå äîñòàâåí </TITLE>
 </HEAD><BODY>
 <H1>ÃÐÅØÊÀ</H1>
Index: squid/errors/Bulgarian/ERR_CONNECT_FAIL
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_CONNECT_FAIL,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_CONNECT_FAIL	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_CONNECT_FAIL	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Çàÿâåíèÿò îáåêò íå ìîæå äà áúäå äîñòàâåí </TITLE>
 </HEAD><BODY>
 <H1>ÃÐÅØÊÀ</H1>
Index: squid/errors/Bulgarian/ERR_DNS_FAIL
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_DNS_FAIL,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_DNS_FAIL	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_DNS_FAIL	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Çàÿâåíèÿò îáåêò íå ìîæå äà áúäå äîñòàâåí </TITLE>
 </HEAD><BODY>
 <H1>ÃÐÅØÊÀ</H1>
Index: squid/errors/Bulgarian/ERR_FORWARDING_DENIED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_FORWARDING_DENIED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_FORWARDING_DENIED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_FORWARDING_DENIED	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Çàÿâåíèÿò îáåêò íå ìîæå äà áúäå äîñòàâåí </TITLE>
 </HEAD><BODY>
 <H1>ÃÐÅØÊÀ</H1>
Index: squid/errors/Bulgarian/ERR_FTP_DISABLED
===================================================================
RCS file: /cvsroot/squid-sf//squid/errors/Bulgarian/ERR_FTP_DISABLED,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.2
diff -u -r1.1.1.1 -r1.1.1.2
--- squid/errors/Bulgarian/ERR_FTP_DISABLED	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/errors/Bulgarian/ERR_FTP_DISABLED	26 Jan 2000 03:25:00 -0000	1.1.1.2
@@ -1,4 +1,5 @@
 <HTML><HEAD>
+<meta http-equiv="Content-Type" content="text/html; charset=windows-1251">
 <TITLE>ÃÐÅØÊÀ: Çàÿâåíèÿò îáåêò íå ìîæå äà áúäå äîñòàâåí </TITLE>
 </HEAD><BODY>
 <H1>ÃÐÅØÊÀ</H1>
